using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace CustomizedGrouping
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			 
			InitializeComponent();

			 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(48, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(384, 360);
			this.gridGroupingControl1.TabIndex = 1;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 422);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridGroupingControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//set gridGroupingControl1 properties
			this.gridGroupingControl1.DataSource = GetADataTable();
			this.gridGroupingControl1.ShowGroupDropArea = true;

			//color "Col2" so it is easier to see
			this.gridGroupingControl1.TableDescriptor.Columns["DateTime"].Appearance.AnyRecordFieldCell.BackColor = Color.LightGoldenrodYellow;
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Changed +=new Syncfusion.Collections.ListPropertyChangedEventHandler(GroupedColumns_Changed);  

		}

		//create the datasource
		private DataTable GetADataTable()
		{
			
			DataTable dt = new DataTable("MyTable");

			int nCols = 3;
			int nRows = 50;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
			dt.Columns.Add("DateTime",typeof(DateTime)); 

			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(100).ToString();
				dr[3] = DateTime.Now; 
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private void GroupedColumns_Changed(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
		{
			if( e.Action == Syncfusion.Collections.ListPropertyChangedType.Insert)
			{
				SortColumnDescriptor column = e.Item as SortColumnDescriptor; 
				if( column.Name == "DateTime")
					column.Categorizer = new CustomCategorizer();
			}
		}
	}


	#region Custom Categorizer class
	//defines custom categorizer
	public class CustomCategorizer : Syncfusion.Grouping.IGroupByColumnCategorizer
	{

		//defines a group and returns a group category object (here returns 1 through 5)
		public static int GetCategory(DateTime date)
		{
			return date.ToString("dd/mm/YYYY").GetHashCode() ;
		}

		#region IGroupByColumnCategorizer Members

		public object GetGroupByCategoryKey(SortColumnDescriptor column, bool isForeignKey, Record record)
		{
			return GetCategory(DateTime.Parse( record.GetValue(column).ToString()));
		}

		public int CompareCategoryKey(SortColumnDescriptor column, bool isForeignKey, object category, Record record)
		{
				return GetCategory( DateTime.Parse(record.GetValue(column).ToString())) - (int)category;
		}

		#endregion
	}
	#endregion
}
